# Copyright (C) 2019 The LineageOS Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

BOARD_VENDOR := sony

VENDOR_PATH := device/sony/loire-common

TARGET_SPECIFIC_HEADER_PATH += $(VENDOR_PATH)/include

# Architecture
TARGET_ARCH := arm64
TARGET_ARCH_VARIANT := armv8-a
TARGET_CPU_ABI := arm64-v8a
TARGET_CPU_ABI2 :=
TARGET_CPU_VARIANT := cortex-a53

TARGET_2ND_ARCH := arm
TARGET_2ND_ARCH_VARIANT := armv8-a
TARGET_2ND_CPU_ABI := armeabi-v7a
TARGET_2ND_CPU_ABI2 := armeabi
TARGET_2ND_CPU_VARIANT := cortex-a53.a57

TARGET_USES_64_BIT_BINDER := true

# TODO
# Bootloader
#TARGET_BOOTLOADER_BOARD_NAME := MSM8974
#TARGET_NO_BOOTLOADER := true
#TARGET_NO_RADIOIMAGE := true

# TODO: Partial
# Kernel
BOARD_KERNEL_BASE := 0x20000000
#BOARD_KERNEL_CMDLINE := androidboot.hardware=qcom ehci-hcd.park=3 lpm_levels.sleep_disabled=1 sched_enable_hmp=1 sched_enable_power_aware=1 service_locator.enable=1 swiotlb=1 androidboot.configfs=true androidboot.usbcontroller=a800000.dwc3 loop.max_part=7
BOARD_KERNEL_IMAGE_NAME := Image.gz-dtb
BOARD_KERNEL_PAGESIZE := 4096
BOARD_KERNEL_TAGS_OFFSET := 0x01e00000
BOARD_RAMDISK_OFFSET := 0x02000000
TARGET_KERNEL_ARCH := arm64
TARGET_KERNEL_SOURCE := kernel/sony/msm8952
TARGET_KERNEL_CLANG_COMPILE := true

# Platform
PRODUCT_PLATFORM_SOD := true
TARGET_BOARD_PLATFORM := msm8952
TARGET_BOARD_PLATFORM_GPU := qcom-adreno510

# TODO
# Audio
#AUDIO_FEATURE_DISABLED_USBAUDIO := true
#AUDIO_FEATURE_ENABLED_EXTN_POST_PROC := true
#BOARD_USES_ALSA_AUDIO := true

# TODO: Partial
# Bluetooth
BOARD_HAVE_BLUETOOTH := true
BOARD_HAVE_BLUETOOTH_BCM := true

# TODO
# Camera
#USE_DEVICE_SPECIFIC_CAMERA := true
#TARGET_HAS_LEGACY_CAMERA_HAL1 := true
#TARGET_USES_MEDIA_EXTENSIONS := true

# TODO
# Camera Shims
#TARGET_LD_SHIM_LIBS := \
#    /system/vendor/bin/credmgrd|/system/vendor/lib/libshims_signal.so \
#    /system/vendor/bin/mm-qcamera-daemon|libandroid.so \
#    /system/vendor/bin/suntrold|/system/vendor/lib/libshims_signal.so \
#    /system/lib/hw/camera.vendor.qcom.so|libsensor.so \
#    /system/lib/libcammw.so|libsensor.so

# TODO
# Charger
BOARD_CHARGER_ENABLE_SUSPEND := true

# TODO
# Filesystem
TARGET_FS_CONFIG_GEN += $(VENDOR_PATH)/config.fs

# TODO
# Graphics
#TARGET_USES_ION := true
#NUM_FRAMEBUFFER_SURFACE_BUFFERS := 3
#OVERRIDE_RS_DRIVER := libRSDriver_adreno.so
#TARGET_USES_GRALLOC1_ADAPTER := true

# TODO
# Shader cache config options
# Maximum size of the  GLES Shaders that can be cached for reuse.
# Increase the size if shaders of size greater than 12KB are used.
#MAX_EGL_CACHE_KEY_SIZE := 12*1024

# TODO
# Maximum GLES shader cache size for each app to store the compiled shader
# binaries. Decrease the size if RAM or Flash Storage size is a limitation
# of the device.
#MAX_EGL_CACHE_SIZE := 2048*1024
#TARGET_ADDITIONAL_GRALLOC_10_USAGE_BITS := 0x02000000U

# TODO
# Lights HAL
#TARGET_PROVIDES_LIBLIGHT := true

# TODO
# Partition information
#BOARD_BOOTIMAGE_PARTITION_SIZE := 20971520
#BOARD_CACHEIMAGE_FILE_SYSTEM_TYPE := ext4
#BOARD_CACHEIMAGE_PARTITION_SIZE := 209715200
#BOARD_RECOVERYIMAGE_PARTITION_SIZE := 16777216
#BOARD_FLASH_BLOCK_SIZE := 131072 # (BOARD_KERNEL_PAGESIZE * 64)

# TODO
#TARGET_USERIMAGES_USE_EXT4 := true
#TARGET_USERIMAGES_USE_F2FS := true

# TODO
# Power
#TARGET_HAS_LEGACY_POWER_STATS := true
#TARGET_HAS_NO_WLAN_STATS := true
#TARGET_USES_INTERACTION_BOOST := true

# TODO
# QCOM hardware
#BOARD_USES_QCOM_HARDWARE := true

# TODO: Partial, check
# Recovery
BOARD_USES_RECOVERY_AS_BOOT := true
TARGET_NO_RECOVERY := true
TARGET_RECOVERY_FSTAB := $(VENDOR_PATH)/rootdir/etc/fstab.qcom
TARGET_RECOVERY_PIXEL_FORMAT := "RGBX_8888"
TARGET_USERIMAGES_USE_EXT4 := true
TARGET_USERIMAGES_USE_F2FS := true

# TODO
# RIL
#TARGET_RIL_VARIANT := caf

# TODO
# Security patch level
#VENDOR_SECURITY_PATCH := 2016-05-01

# TODO
# SELinux
#include device/qcom/sepolicy-legacy/sepolicy.mk

# TODO
#BOARD_SEPOLICY_DIRS += \
#    $(COMMON_PATH)/sepolicy

# SODP build barrier
PRODUCT_PLATFORM_SOD := true

# Treble
#DEVICE_MANIFEST_FILE := $(COMMON_PATH)/manifest.xml

# Kernel
BOARD_KERNEL_CMDLINE := androidboot.bootdevice=7824900.sdhci

# TODO
# Audio
#AUDIO_FEATURE_DISABLED_FM_VIRTUAL_RECORD := true
#AUDIO_FEATURE_ENABLED_ANC_HEADSET := true
#AUDIO_FEATURE_ENABLED_AUXPCM_BT := true
#AUDIO_FEATURE_ENABLED_EXTN_FORMATS := true
#AUDIO_FEATURE_ENABLED_HFP := true
#AUDIO_FEATURE_ENABLED_HWDEP_CAL := true
#AUDIO_FEATURE_ENABLED_MULTI_VOICE_SESSIONS := true
#AUDIO_FEATURE_ENABLED_MULTIPLE_TUNNEL := true
#AUDIO_FEATURE_ENABLED_NEW_SAMPLE_RATE = true
#AUDIO_FEATURE_ENABLED_PROXY_DEVICE := true
#AUDIO_FEATURE_LOW_LATENCY_PRIMARY := true
#
#USE_CUSTOM_AUDIO_POLICY := 1
#USE_XML_AUDIO_POLICY_CONF := 1

# TODO
# Binder API version
#TARGET_USES_64_BIT_BINDER := true

# TODO
# Bluetooth
#BOARD_HAVE_BLUETOOTH_BCM := true
#BOARD_BLUETOOTH_BDROID_BUILDCFG_INCLUDE_DIR := $(COMMON_PATH)/bluetooth
#BOARD_CUSTOM_BT_CONFIG := $(COMMON_PATH)/bluetooth/vnd_loire.txt

# TODO
# BT/FM (Broadcom): Adjust the sysfs patch for 3.4 kernel
#BOARD_HAVE_BCM_FM_SYSFS := "/sys/bus/platform/drivers/bcm_ldisc/bcm_ldisc/"
#BOARD_BRCM_HCI_NUM := 26

# TODO
# Camera
#TARGET_USES_MEDIA_EXTENSIONS := true

# TODO
# Filesystem
#TARGET_FS_CONFIG_GEN += $(COMMON_PATH)/config.fs

# TODO
# FM
#BOARD_HAVE_BCM_FM := true

# TODO
# Init
#TARGET_INIT_VENDOR_LIB := libinit_loire

# TODO
# Partition information
#BOARD_SYSTEMIMAGE_PARTITION_SIZE := 2671771648
#BOARD_USERDATAIMAGE_PARTITION_SIZE := 12656294912
#BOARD_ROOT_EXTRA_FOLDERS := lta-label

# TODO
# Recovery
#TARGET_RECOVERY_FSTAB := $(COMMON_PATH)/rootdir/etc/fstab.qcom
#TARGET_RECOVERY_PIXEL_FORMAT := "RGBA_8888"

# TODO
# SELinux
#BOARD_SEPOLICY_DIRS += \
#    $(COMMON_PATH)/sepolicy

# TODO
# Sensors
#USE_SENSOR_MULTI_HAL := true

# TODO
# Shims
#TARGET_LD_SHIM_LIBS += \
#    /system/lib/libsomc_chokoballpal.so|/vendor/lib/libshim_camera.so

# TODO
# Wifi
#BOARD_WLAN_DEVICE := bcmdhd
#BOARD_WPA_SUPPLICANT_DRIVER := NL80211
#WPA_SUPPLICANT_VERSION := VER_0_8_X
#BOARD_WPA_SUPPLICANT_PRIVATE_LIB := lib_driver_cmd_bcmdhd
#BOARD_HOSTAPD_DRIVER := NL80211
#BOARD_HOSTAPD_PRIVATE_LIB := lib_driver_cmd_bcmdhd
#WIFI_DRIVER_FW_PATH_PARAM := "/sys/module/bcmdhd/parameters/firmware_path"
#WIFI_DRIVER_FW_PATH_AP := "/vendor/firmware/fw_bcmdhd_apsta.bin"
#WIFI_DRIVER_FW_PATH_STA := "/vendor/firmware/fw_bcmdhd.bin"

# Inherit from the proprietary version
-include vendor/sony/loire-common/BoardConfigVendor.mk
